package com.steerinfo.meterwork.meterworkcalibrationmain.controller;

import com.steerinfo.baseinfo.meterbasecalibrarelation.model.MeterBaseCalibraRelation;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.dto.CombinationList;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcalibrationmain.model.MeterWorkCalibrationMain;
import com.steerinfo.meterwork.meterworkcalibrationmain.service.IMeterWorkCalibrationMainService;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkCalibrationMain RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-09-25 02:57
 * 类描述
 * 修订历史：
 * 日期：2020-09-25
 * 作者：generator
 * 参考：
 * 描述：MeterWorkCalibrationMain RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkcalibrationmains")
@Api(value = "/${api.version}/meterworkcalibrationmains", tags = "校秤记录数据主表 - MeterWorkCalibrationMainController")
public class MeterWorkCalibrationMainController extends BaseRESTfulController {

    @Autowired
    IMeterWorkCalibrationMainService meterWorkCalibrationMainService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcalibrationmain:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkCalibrationMain> list = meterWorkCalibrationMainService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcalibrationmain:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkCalibrationMain> list = meterWorkCalibrationMainService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkCalibrationMain对象创建")
    @ApiImplicitParam(name = "meterWorkCalibrationMain", value = "详细实体meterWorkCalibrationMain", required = true, dataType = "MeterWorkCalibrationMain")
    //@RequiresPermissions("meterworkcalibrationmain:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkCalibrationMain model) {
        try {
            MeterWorkCalibrationMain meterWorkCalibrationMain = meterWorkCalibrationMainService.add(model);
            return success(meterWorkCalibrationMain);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkcalibrationmain:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkCalibrationMain meterWorkCalibrationMain = meterWorkCalibrationMainService.getById(id);
            return success(meterWorkCalibrationMain);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkCalibrationMain信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkCalibrationMain", value = "详细实体meterWorkCalibrationMain", required = true, dataType = "MeterWorkCalibrationMain")
    })
    //@RequiresPermissions("meterworkcalibrationmain:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkCalibrationMain model) {
        try {
            model.setId(id);
            MeterWorkCalibrationMain meterWorkCalibrationMain = meterWorkCalibrationMainService.modify(model);
            return success(meterWorkCalibrationMain);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkcalibrationmain:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkCalibrationMainService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "WF获取列表")
    @PostMapping(value = "/doQueryWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doQueryWf(@RequestBody MeterWorkCalibrationMain oci) {
        try {
            RESTfulResult rm = meterWorkCalibrationMainService.doQueryWf(oci);
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "查询还未完成的校秤类型", notes = "根据url的实体集来指定删除对象")
    @PostMapping(value = "/doQueryCalibrationWf")
    public RESTfulResult doQueryCalibrationWf(@RequestBody MeterWorkCalibrationMain model) {
        try {
            List<MeterBaseCalibraRelation> hms = meterWorkCalibrationMainService.doQueryCalibrationWf(model);
            return success(hms);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "WF获取最近十条的数据")
    @PostMapping(value = "/doQuerySomeWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doQuerySomeWf(@RequestBody CommonPage<MeterWorkCalibrationMain> oci) {
        try {
            CombinationList cl = meterWorkCalibrationMainService.doQuerySomeWf(oci.getParam().getBaseSpotNo(), oci.getPageSize());
            return success(cl);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
